/******************************************************************************
 * Job:             Load_STG2DM_Scope                       A5W0V4GZ.BF0004LP *
 * Description:                                                               *
 *                                                                            *
 * Metadata Server: puneasd10.apac.sas.com                                    *
 * Port:            8561                                                      *
 * Location:        /Users/Gyan/My Folder/M1MI42                              *
 *                                                                            *
 * Server:          MIMain                                  A5W0V4GZ.AR000003 *
 *                                                                            *
 * Source Tables:   SCOPE - DI_DM2.SCOPE                    A5W0V4GZ.BB0005ON *
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB00099S *
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB0003KY *
 *                  STG_SCOPE - DIDM_STG.STG_SCOPE          A5W0V4GZ.BB00097M *
 *                  CALENDAR - DI_DM2.CALENDAR              A5W0V4GZ.BB0005O8 *
 *                  CALENDAR - DI_DM2.CALENDAR              A5W0V4GZ.BB0005O8 *
 *                  RPP_PLAN - DI_DM2.RPP_PLAN              A5W0V4GZ.BB0005OJ *
 *                  PRODUCT_HIER_ASSOC_DM -                 A5W0V4GZ.BB0009CK *
 *                   DI_DM.PRODUCT_HIER_ASSOC_DM                              *
 *                  GEOGRAPHY_HIER_ASSOC_DM -               A5W0V4GZ.BB00099T *
 *                   DI_DM.GEOGRAPHY_HIER_ASSOC_DM                            *
 * Target Tables:   SCOPE - DI_DM2.SCOPE                    A5W0V4GZ.BB0005ON *
 *                  CALENDAR - DI_DM2.CALENDAR              A5W0V4GZ.BB0005O8 *
 *                  RPP_PLAN - DI_DM2.RPP_PLAN              A5W0V4GZ.BB0005OJ *
 *                  SCOPE_DETAIL - DI_DM2.SCOPE_DETAIL      A5W0V4GZ.BB0005OO *
 *                  RPP_OBJECT_ASSOC -                      A5W0V4GZ.BB0005OI *
 *                   DI_DM2.RPP_OBJECT_ASSOC                                  *
 *                  RPP_NOTIFICATION -                      A5W0V4GZ.BB000AES *
 *                   DI_DM2.RPP_NOTIFICATION                                  *
 *                  RPP_NOTIFICATION -                      A5W0V4GZ.BB000AES *
 *                   DI_DM2.RPP_NOTIFICATION                                  *
 *                                                                            *
 * Generated on:    Monday, May 17, 2010 4:48:49 PM IST                       *
 * Generated by:    singyg@row                                                *
 * Version:         SAS Data Integration Studio 4.2                           *
 ******************************************************************************/

/* General macro variables  */
%let jobID = %quote(A5W0V4GZ.BF0004LP);
%let etls_jobName = %nrquote(Load_STG2DM_Scope);
%let etls_userID = %nrquote(singyg@row);

/* Setup to capture return codes  */
%global job_rc trans_rc sqlrc;
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr;

/* Setup for capturing job status  */
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug;
%macro etls_setDebug;
   %if %str(&etls_debug) ne 0 %then
      OPTIONS MPRINT%str(;);
%mend;
%etls_setDebug;

/*---- Start of Pre-Process Code  ----*/

%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));

/*---- End of Pre-Process Code  ----*/
%di_etl_rcSet(error=&syserr,code=job_rc);
%di_etl_rcSet(error=&sqlrc,code=job_rc);


/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            Uw_check_exist                          A5W0V4GZ.BH0007SE *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    STG_SCOPE - DIDM_STG.STG_SCOPE          A5W0V4GZ.BB0003QP *
 * Target Table:    Uw_check_exist - DIDM_STG.STG_SCOPE     A5W0V4GZ.BK0006CJ *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH0007SE);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);


%macro etl_check_exist;

%let abort = 0 ;
%global etl_promo_geo_hier;

/***************************************************/
/* Check for existence of DI_DM.PRODUCT_DM dataset */
/***************************************************/

%if NOT %sysfunc(exist(DI_DM.PRODUCT_DM)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.PRODUCT_DM);
      %put &etl_msg;
      %let abort = 1 ;
   %end;

/*****************************************************/
/* Check for existence of DI_DM.GEOGRAPHY_DM dataset */
/*****************************************************/

%if NOT %sysfunc(exist(DI_DM.GEOGRAPHY_DM)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.GEOGRAPHY_DM);
      %put &etl_msg;
      %let abort = 2 ;
   %end;

/**************************************************/
/* Check for existence of DI_DM2.CALENDAR dataset */
/**************************************************/
%if NOT %sysfunc(exist(DI_DM2.CALENDAR)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM2.CALENDAR);
      %put &etl_msg;
      %let abort = 3;
   %end;

/**********************************************************/
/* Check for existence of DI_DM2.RPP_OBJECT_ASSOC dataset */
/**********************************************************/
%if NOT %sysfunc(exist( DI_DM2.RPP_OBJECT_ASSOC)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args= DI_DM2.RPP_OBJECT_ASSOC);
      %put &etl_msg;
      %let abort = 4;
   %end;

/**********************************************************/
/* Check for existence of DI_DM2.RPP_NOTIFICATION dataset */
/**********************************************************/
%if NOT %sysfunc(exist( DI_DM2.RPP_NOTIFICATION)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args= DI_DM2.RPP_NOTIFICATION);
      %put &etl_msg;
      %let abort = 5;
   %end;

/***************************************/
/*check for existance of promo_geo_hier*/
/***************************************/

proc sql noprint;
   select spec_value into :etl_promo_geo_hier
   from di_dm.global_setting
   where upcase(spec_nm) = 'PROMO_GEO_HIER';
quit;

%if &etl_promo_geo_hier eq %str() %then
%do;
   %let etl_msg = %etl_msg(mid=5007,args=PROMO_GEO_HIER GLOBAL_SETTING);
   %put &etl_msg;
   %let abort=6;
%end;

%if NOT %sysfunc(exist(Didm_stg.Stg_scope_relation)) %then
%do;
   data didm_stg.stg_scope_relation;
      attrib scope_nm length = $120;
      attrib scope_sk length = 8;
      stop;
   run;
%end;

%if &abort gt 0 %then
   %do;
      %etl_abort;
   %end;


%put PROMO_GEO_HIER=&etl_promo_geo_hier;

%mend etl_check_exist;

%etl_check_exist;


/*============================================================================*
 * Step:            lkp_hier_sk                             A5W0V4GZ.BH000MKQ *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   Sort_stg_scope - work.Sort_stg_scope    A5W0V4GZ.BK000IRG *
 *                  GEOGRAPHY_DM - DI_DM.GEOGRAPHY_DM       A5W0V4GZ.BB00099S *
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB0003KY *
 * Target Table:    lkp_hier_sk - work.lkp_hier_sk1         A5W0V4GZ.BK000IRH *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000MKQ);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let runTime = %sysfunc(datetime());

proc datasets lib = work nolist nowarn memtype = (data view);
   delete lkp_hier_sk1;
quit;

/*---- Begin DATA step to perform lookups  ----*/
DATA  work.lkp_hier_sk1
         ( keep = OBJECT_NM OBJECT_CAT_TYPE GEO_ID PROD_ID GEO_HIER_ASSOC_CD
                 PROD_HIER_ASSOC_CD GEO_HIER_SK PROD_HIER_SK )

      work.invalid_scope_IDs
         ( keep = OBJECT_NM OBJECT_CAT_TYPE GEO_ID PROD_ID ERR_FLG)
      ;

   attrib OBJECT_NM length=$100
          OBJECT_CAT_TYPE length=4
          GEO_ID length=$32
          PROD_ID length=$32
          GEO_HIER_ASSOC_CD length=4
          PROD_HIER_ASSOC_CD length=4
          GEO_HIER_SK length=4
          PROD_HIER_SK length=6
          ERR_FLG length=$2;

   retain missing0-missing1 0;

   ERR_FLG = '';

   /* Build hash objects from lookup tables before reading first source row  */
   if (_n_ = 1) then
   do;
      /* Build hash h0 from lookup table DI_DM.GEOGRAPHY_DM */
      nlobs = .;
      dsid = open("DI_DM.GEOGRAPHY_DM");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h0(dataset: "DI_DM.GEOGRAPHY_DM", hashexp: exponent);
            h0.defineKey( "GEO_ID");
            h0.defineData( "GEO_HIER_SK");
            h0.defineDone();
            if (nlobs = -1) then
            do;
               if (h0.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
                  missing0 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_DM.GEOGRAPHY_DM";
            missing0 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_DM.GEOGRAPHY_DM";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.GEOGRAPHY_DM";

         abort 3;
      end;

      /* Build hash h1 from lookup table DI_MON.PROD_HIER_SK */
      nlobs = .;
      dsid = open("DI_MON.PROD_HIER_SK");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h1(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
            h1.defineKey( "PROD_ID");
            h1.defineData( "PROD_HIER_SK");
            h1.defineDone();
            if (nlobs = -1) then
            do;
               if (h1.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing1 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
            missing1 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_MON.PROD_HIER_SK";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_MON.PROD_HIER_SK";

         abort 3;
      end;

      call missing (GEO_ID, GEO_HIER_SK, PROD_ID, PROD_HIER_SK);

   end; /* All hash objects have been defined */

   /* Read a row from the source table  */
   set DIDM_STG.STG_SCOPE end = eof;
   PROD_HIER_ASSOC_CD = 1;
   GEO_HIER_ASSOC_CD = &etl_promo_geo_hier;
   if object_cat_type = 11 then object_cat_type = 10;

   /* Is the current key value stored in hash h0?  */
   if (missing0 < 1) then
   do;
      rc0 = h0.find();
   end;
   else
      rc0 = missing0;

   /* Is the current key value stored in hash h1?  */
   if (missing1 < 1) then
   do;
      rc1 = h1.find();
   end;
   else
      rc1 = missing1;

   /* Examine success of lookups  */
   if ( rc0=0 and rc1=0 ) then
   do;
      /* Write row to target  */
      output work.lkp_hier_sk1;
      return;
   end;
   else
   do;
      if rc0 ne 0 then ERR_FLG = 'G';
      if rc1 ne 0 then ERR_FLG = cats(ERR_FLG,'P');

      error_total + 1;
      output work.invalid_scope_IDs;
   end; /* One or more lookups failed */

   if (eof = 1) then
   do;
      put "Source records with errors: " error_total ;
   end;

run;

%di_etl_rcSet(error=&syserr,code=job_rc);

data work.invalid_scope_IDs;
   set work.invalid_scope_IDs;
   attrib ETL_Error_JobRunTime length=8 format=datetime16.
          ETLS_EXCEPTION_COND length = $300;
   ETL_Error_JobRunTime = "&etls_stepStartTime"dt;
   if index(ERR_FLG,'G') gt 0 then do;
      ETLS_EXCEPTION_COND = put("%etl_msg(mid=5305,args=GEO_ID)",$300.);
   end;
   if index(ERR_FLG,'P') gt 0 then do;
      ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_ID)"),$300.);
   end;
   drop ERR_FLG;
run;

/* update the errors table  */
proc append base = DI_MON.STG_SCOPE_X
            data = work.invalid_scope_IDs force;
run;

/**  Step end lkp_hier_sk **/

/*============================================================================*
 * Step:            Lkp_assoc_cd                            A5W0V4GZ.BH000MKT *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   lkp_hier_sk - work.lkp_hier_sk1         A5W0V4GZ.BK000IRH *
 *                  product_hier_assoc_dm -                 A5W0V4GZ.BK000IRI *
 *                  geography_hier_assoc_dm -               A5W0V4GZ.BK000IRJ *
 * Target Table:    Lookup - work.stg_scope_in_hier         A5W0V4GZ.BK000IRK *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000MKT);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%di_etl_keep_work_table(lkp_hier_sk1);

%let runTime = %sysfunc(datetime());

proc datasets lib = work nolist nowarn memtype = (data view);
   delete stg_scope_in_hier;
quit;

proc sql;
   create table stg_scope_in_hier as
   select a.*,
          ph.parent_prod_hier_sk,
          gh.parent_geo_hier_sk
     from work.lkp_hier_sk1 as a
     left join di_dm.product_hier_assoc_dm as ph
       on a.prod_hier_sk        = ph.prod_hier_sk
      and ph.prod_hier_assoc_cd = 1
      and ph.parent_prod_lvl    = 1
     left join di_dm.geography_hier_assoc_dm gh
       on a.geo_hier_sk         = gh.geo_hier_sk
      and gh.geo_hier_assoc_cd  = &etl_promo_geo_hier
      and gh.parent_geo_lvl     = 1;
quit;

%di_etl_rcSet(error=&sqlrc,code=job_rc);

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            Val_scope_sk                            A5W0V4GZ.BH0009CQ *
 * Transform:       Data Validation                                           *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Lookup - work.stg_scope_in_hier         A5W0V4GZ.BK0007YH *
 * Target Table:    Val_scope_sk - work.Val_scope_sk        A5W0V4GZ.BK0007LC *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/
%di_etl_keep_work_table(stg_scope_in_hier);

%macro etls_Validate;

   %let runTime = %sysfunc(datetime());

   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Val_scope_sk etls_Errors;
   quit;

   /*---- Begin checks for Custom, Missing Values, and Invalid Values  ----*/
   data work.Val_scope_sk
         (keep = OBJECT_NM OBJECT_CAT_TYPE GEO_ID PROD_ID GEO_HIER_ASSOC_CD
                         PROD_HIER_ASSOC_CD GEO_HIER_SK PROD_HIER_SK )
        work.etls_Errors
         (keep = OBJECT_NM OBJECT_CAT_TYPE GEO_ID PROD_ID ETLS_EXCEPTION_COND );

      /* Define lengths for columns with longer lengths in target  */
      attrib ETLS_EXCEPTION_COND length = $300;

      set stg_scope_in_hier end=eof;

      i_move = 0;

      /*---- Custom Validation: OBJECT_TYP  ----*/
      if ( NOT (OBJECT_CAT_TYPE IN &etlp_rpp_object_type)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=OBJECT_CAT_TYPE)"),$300.);
      end;

      /*---- Custom Validation: Missing Geo_id  ----*/
      if (MISSING(PARENT_GEO_HIER_SK)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"GEO_ID_not_in_GEO_HIER_ASSOC_CD_=&etl_promo_geo_hier"),$300.);
      end;

      /*---- Custom Validation: Missing Prod_id  ----*/
      if (MISSING(PARENT_PROD_HIER_SK)) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,'PROD_ID_not_in_standard_hierarchy'),$300.);
      end;

      /*---- Custom Validation: Remove invalid records  ----*/
      if (ETLS_EXCEPTION_COND ne " ") then
      do;
         output work.etls_Errors;
      end;
      else do;
         output work.Val_scope_sk;
      end;

   run;

   %di_etl_rcSet(error=&syserr,code=job_rc);

   /* add ETL_Error_JobRunTime variable to error table  */
   data work.etls_Errors;
      set work.etls_Errors;
      format ETL_Error_JobRunTime datetime16.;
      ETL_Error_JobRunTime = "&etls_stepStartTime"dt;
   run;

   /* update the errors table  */
   proc append base = DI_MON.STG_SCOPE_X
               data = work.etls_Errors force;
   run;

%mend etls_Validate;

%etls_Validate;

/*============================================================================*
 * Step:            Sort and Remove duplicates                                *
 * Transform:       Sort                                                      *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Lookup - work.Val_scope_sk                                *
 * Target Table:    work.Val_scope_sk_sort                                    *
 *                  work.dups_scope_sk                                        *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%di_etl_keep_work_table(Val_scope_sk);

proc sort data = work.Val_scope_sk
        dupout = work.dups_scope_sk
           out = work.Val_scope_sk_sort
        nodupkey;
   by
      OBJECT_NM
      OBJECT_CAT_TYPE
      GEO_HIER_SK
      PROD_HIER_SK
   ;
run;

data dups_scope_sk(keep=%di_util_column_names(didm_stg.stg_scope)
                        etls_exception_cond
                        ETL_Error_JobRunTime);
   attrib etls_exception_cond length=$300;
   attrib ETL_Error_JobRunTime length=8 format=datetime16.;
   set work.dups_scope_sk;
   etls_exception_cond = "%etl_msg(mid=5303,args=record)";
   ETL_Error_JobRunTime = "&etls_stepStartTime"dt;
run;

proc append base = di_mon.STG_SCOPE_X
            data=WORK.dups_scope_sk
                 (keep=%di_util_column_names(di_mon.STG_SCOPE_X));
run;

/*---- End of User Written Code  ----*/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            gen_scope_nm_desc                       A5W0V4GZ.BH0007SJ *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Val_scope_sk - work.Val_scope_sk        A5W0V4GZ.BK0006CN *
 * Target Table:    gen_scope_nm_desc -                     A5W0V4GZ.BK0006CO *
 *                   work.gen_scope_nm_desc                                   *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/
%di_etl_keep_work_table(Val_scope_sk_sort);

%let transformID = %quote(A5W0V4GZ.BH0007SJ);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

data work.valid_scope_detail (keep = scope_nm prod_hier_sk geo_hier_sk)
     work.valid_scope (keep = scope_nm scope_desc geo_hier_assoc_cd prod_hier_assoc_cd);

   set work.Val_scope_sk_sort;
   length scope_nm $120 scope_desc $100;
   by object_nm object_cat_type;

   SCOPE_NM = cats(OBJECT_NM,'-',OBJECT_CAT_TYPE);
   SCOPE_DESC = SCOPE_NM;

   if first.object_cat_type then do;
      output work.valid_scope;
   end;
   output work.valid_scope_detail;
run;

%di_etl_rcSet(error=&syserr,code=job_rc);

%di_etl_rcSet(error=&sqlrc,code=job_rc);

/************************************************************************************************************
The macro related_scope will match the scope in stage and datamart and remove the scope from stage,
if a match is found in stage  or datamart.A relation entry will be created in work.stg_scope_relation_tmp
for the matching scope.
*************************************************************************************************************/

%macro related_scope (stg_scope_table        = ,
                      stg_scope_detail_table = ,
                      _scope_relation_output = ,
                      _scope_detail_output   = );

   /************************* START-Find duplicate scope in Stage ******************************************/

   proc sql;
       create table work.stg_scope_stat as
       select scope_nm, count(distinct(prod_hier_sk)) as num_prod,
                        count(distinct(geo_hier_sk)) as num_geo,
                        sum(distinct(prod_hier_sk)) as sum_prod,
                        sum(distinct(geo_hier_sk)) as sum_geo,
                        count(*) as num_geo_prod,
                        round(std(prod_hier_sk),0.001) as stdprod,
                        round(std(geo_hier_sk),0.001) as stdgeo
       from &stg_scope_detail_table
       group by scope_nm;
   quit;

   proc sort data = work.stg_scope_stat
             dupout = work.stg_scope_any_dup
             nodupkey;
      by num_prod num_geo num_geo_prod sum_prod sum_geo stdprod stdgeo;
   run;

   /*
    * work.stg_scope_any_dup table could have potential duplicates
    * but we dont know at this time .
    * Find out in <stg_scope_detail_table> if they have real duplicates
    */

   proc sql;
       create table duplicate_scope_in_stg as
       select distinct
              a.scope_nm as related_scope_nm,
              b.scope_nm
         from &stg_scope_detail_table a,
              &stg_scope_detail_table b,
              work.stg_scope_any_dup dup,
              work.stg_scope_stat nondup
        where a.prod_hier_sk = b.prod_hier_sk
          and a.geo_hier_sk = b.geo_hier_sk
          and a.scope_nm = nondup.scope_nm
          and b.scope_nm = dup.scope_nm
          and nondup.num_prod = dup.num_prod
          and nondup.num_geo = dup.num_geo
          and nondup.num_geo_prod = dup.num_geo_prod
     group by a.scope_nm,
              b.scope_nm
       having count(*) = dup.num_geo_prod
   ;
   quit;

   /* Now you have the duplicate scope [scope_Nm], which can be taken out of stg_scope and
      relation entry needs to be preserved */

   proc sql;
      delete from &stg_scope_table
      where scope_nm in (select scope_nm from duplicate_scope_in_stg);

      delete from &stg_scope_detail_table
      where scope_nm in (select scope_nm from duplicate_scope_in_stg);
   quit;

   /* Remerge statistics with stg_scope */
   proc sort data=stg_scope_stat;
      by scope_nm;
   quit;

   proc sort data=stg_scope_any_dup;
      by scope_nm;
   quit;

   data &_scope_detail_output;
      merge &stg_scope_detail_table (in = stg)
            work.stg_scope_stat (keep = scope_nm num_prod num_geo num_geo_prod)
            work.stg_scope_any_dup (keep = scope_nm num_prod num_geo num_geo_prod);
      by scope_nm;
      if stg;
   run;

   %di_etl_rcSet(error=&sqlrc,code=job_rc);
   /*************************END-Find Matching scope in stage******************************************/
   /******************************************************************************************************/

   /*************************START-Find Matching scope in Datamart******************************************/

   %di_dm_trans_extract(
      di_trans      = di_dm2,
      trans_table   = scope,
      all_trans     = 0,
      _output_table = ext_scope);

   data di_trans.scope_detail_to_fetch;
      set &_scope_detail_output;
   run;

   %di_dm_trans_extract(
      di_trans      = di_dm2,
      trans_table   = scope_detail,
      all_trans     = 0,
      _output_table = scope_detail,
      select_list   = %str(A.SCOPE_SK,A.PROD_HIER_SK ,A.GEO_HIER_SK),
      filter_cond   = %str(SCOPE_SK in (select d.scope_sk
                                          from di_trans.scope_detail d
                                         inner join di_trans.scope_detail_to_fetch stg on
                                               (D.PROD_HIER_SK = stg.prod_hier_sk and
                                                D.GEO_HIER_SK = stg.geo_hier_sk))));


   proc datasets lib = di_trans nolist nowarn memtype = (data view);
      delete scope_detail_to_fetch;
   quit;

   proc sql;
      create table related_scope_in_dm  as
        select scope_sk,
               prod_hier_sk ,
               geo_hier_sk ,
               count(*) as num_geo_prod
          from scope_detail as a
         group by a.scope_sk;
  quit;


   /** Match stage records with scope_detail to find the related scope_sk **/

   proc sql;
      create table matching_scope_in_dm as
      select distinct stg.scope_nm,
                      dm.scope_sk
        from &_scope_detail_output as stg,
             work.related_scope_in_dm as dm
       where stg.prod_hier_sk = dm.prod_hier_sk
         and stg.geo_hier_sk  = dm.geo_hier_sk
         and stg.num_geo_prod = dm.num_geo_prod
       group by stg.scope_nm,
                dm.scope_sk
      having count(*) = stg.num_geo_prod;
   quit;


   /* If there are duplicate relation then duplicate record can be remove. */
   proc sort data = work.matching_scope_in_dm
      nodupkey;
      by scope_nm;
   run;

   /**Remove the entry from stage if a match is found**/
   proc sql noprint;
      delete
        from &stg_scope_table
       where scope_nm in (select scope_nm from matching_scope_in_dm);
     delete
       from &_scope_detail_output
      where scope_nm in (select scope_nm from matching_scope_in_dm);
   quit;

   %di_etl_rcSet(error=&syserr,code=job_rc);

   /*************************END-Find Matching scope in Datamart******************************************/

   /* If the related scope (duplicate_scope_in_stg) for stage is present in matching_scope_in_dm.
    * Then get the scope_sk from matching_scope_in_dm.
    */

   Proc sql;
      create table work.duplicate_scope_in_stg_final as
         select a.scope_nm,
                coalesce(b.scope_nm,a.related_scope_nm) as related_scope_nm,
                b.scope_sk
           from work.duplicate_scope_in_stg a left join work.matching_scope_in_dm b
             on a.related_scope_nm = b.scope_nm;
   quit;


   /* Append the match created from stage and datamart */
   data &_scope_relation_output;
      set matching_scope_in_dm duplicate_scope_in_stg_final;
   run;

   %di_etl_rcSet(error=&syserr,code=job_rc);

%mend related_scope;

%related_scope(stg_scope_table        = work.Valid_scope,
               stg_scope_detail_table = work.Valid_scope_detail,
               _scope_relation_output = work.stg_scope_relation_tmp,
               _scope_detail_output   = work.unique_scope_detail);

/*---- End of User Written Code  ----*/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            Add valid scope entry to DI_DM2.SCOPE                     *
 *============================================================================*/
%di_etl_keep_work_table(Valid_scope stg_scope_relation_tmp unique_scope_detail);

%let etls_recordsBefore = 0;

%let etls_table = %nrquote(SCOPE);
%let etls_lib   = %nrquote(DI_DM2);

%macro etls_recordCheck(source_table = , _record_count_var = );
   %let etls_recCheckExist = %eval(%sysfunc(exist(&source_table, DATA)) or
         %sysfunc(exist(&source_table, VIEW)));

   %if (&etls_recCheckExist) %then
   %do;
        proc sql noprint;
        select count(*) into :&_record_count_var from &source_table;
        quit;
   %end;
%mend etls_recordCheck;

%etls_recordCheck(source_table = DI_DM2.SCOPE,
                  _record_count_var = etls_recordsBefore);

%di_dm_trans_append(
   di_trans=di_dm2,
   trans_table=scope,
   append_table=Valid_scope,
   bulkload=0,
   fk_flag=0,
   upload_flag=0
);

/* Get number of records in table  */
%let etls_recordsAfter = 0;
%etls_recordCheck(source_table = DI_DM2.SCOPE,
                  _record_count_var = etls_recordsAfter);

%etls_sendJobStatus(source_table = DIDM_STG.STG_SCOPE);

/*============================================================================*
 * Step:          Get scope_sk for related_scope_nm from recently added scope *
 *============================================================================*/
%di_etl_keep_work_table(Valid_scope stg_scope_relation_tmp unique_scope_detail);

%let transformID = %quote(A5W0V4GZ.BH0007SM);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%di_dm_trans_extract(
   di_trans      = di_dm2,
   trans_table   = scope,
   all_trans     = 0,
   select_list   = %str(A.scope_nm,max(A.scope_sk) as scope_sk),
   filter_table  = Valid_scope,
   filter_cond   = %str(A.scope_nm = B.scope_nm group by A.scope_nm order by A.scope_nm),
   _output_table = recent_scope_sk
   );

/* If field scope_sk has missing value in table stg_scope_relation_tmp then the scope_sk has to be
   obtained from scope table */

proc sql;
   update work.stg_scope_relation_tmp rel
      set scope_sk = (select scope_sk
                        from recent_scope_sk
                       where scope_nm = related_scope_nm)
    where scope_sk is Null;
quit;

%di_etl_rcSet(error=&sqlrc,code=job_rc);
%di_etl_rcSet(error=&syserr,code=job_rc);

/* At this time scope_sk should be populated for records in relation.
   including duplicate scope in stage and matching scope in DM.
   If not then there's something wrong in processing */

data _null_;
   set stg_scope_relation_tmp;
   where scope_sk is Null;
   put 'WARNING: SCOPE_SK could not be matched for scop_nm:' scope_nm 'Related Scope_nm:' related_Scope_nm;
run;

%di_etl_rcSet(error=&sqlrc,code=job_rc);

/* Create the didm_stg.stg_scope_relation which will contain the scope name and mapped scope_sk */
%di_util_truncate_table(didm_stg.stg_scope_relation);

Proc append base = didm_stg.stg_scope_relation
            data = work.stg_scope_relation_tmp (keep = scope_nm scope_sk)
            force;
run;

%di_etl_rcSet(error=&sqlrc,code=job_rc);

/*============================================================================*
 * Step:            Update scope_SK and objective_sk for plans                *
 *============================================================================*/
%macro update_plan_and_cal_scope;

   /* Get a list of plans and calendars from stg_scope for which a scope is provided.
      We dont know if scope has changed at this point.
      We'll use this table to update Rpp_plan and Calendar respectively
   */

   data work.stg_rpp_plan_scope_update
        work.stg_calendar_scope_update;

      set work.recent_scope_sk
          didm_stg.stg_scope_relation;

      length object_cat_type 4 object_nm $100;

      object_nm = substr(scope_nm,1,findc(scope_nm,'-',-length(scope_nm))-1);
      object_cat_type = input(scan(scope_nm,-1,'-'),best.);
      if object_cat_type in (1,2,3,4) then
         output work.stg_calendar_scope_update;
      if object_cat_type eq 10 then
         output work.stg_rpp_plan_scope_update;
      drop scope_nm;
   run;

   %di_dm_trans_extract(
      di_trans=di_dm2,
      trans_table=rpp_plan,
      all_trans=0,
      _output_table=work.rpp_plan,
      select_list=%str(a.plan_sk,a.plan_id,a.scope_sk as dm_scope_sk),
     filter_cond= %str(a.status_cd < 2)
   );

   proc sql;
      create index plan_id on work.rpp_plan;
   quit;

   data work.stg_rpp_plan_scope_update(keep = plan_sk scope_sk object_nm object_cat_type);
      set work.stg_rpp_plan_scope_update;
      plan_id = object_nm;
      set work.rpp_plan key=plan_id;
      if _iorc_ eq 0 then do;
         if dm_scope_sk ne scope_sk then output;
      end;
      _iorc_ = 0;
      _error_= 0;
   run;

   %di_dm_trans_extract(
      di_trans=di_dm2,
      trans_table=calendar,
      all_trans=0,
      _output_table=calendar,
      select_list=%str(a.cal_sk,a.cal_nm,a.cal_type,a.scope_sk as dm_scope_sk)
      );

   proc sql;
      create index cal_id on calendar(cal_nm, cal_type);
   quit;

   data work.stg_calendar_scope_update(keep = cal_sk scope_sk cal_type cal_nm);
      set work.stg_calendar_scope_update;
      cal_nm = object_nm;
      cal_type = object_cat_type;
      set work.calendar key=cal_id;
      if _iorc_ eq 0 then do;
         if dm_scope_sk ne scope_sk then output;
      end;
      _iorc_ = 0;
      _error_= 0;
   run;

   %if (&DI_TRANS_VENDOR eq SAS) %then %do;

       Proc sql;
          update di_dm2.rpp_plan p
             set SCOPE_SK = (SELECT ec.SCOPE_SK
                             FROM work.stg_rpp_plan_scope_update ec
                            WHERE p.plan_sk = ec.plan_sk),
                 OBJECTIVE_SK = (SELECT ec.SCOPE_SK
                                 FROM work.stg_rpp_plan_scope_update ec
                                WHERE p.plan_sk = ec.plan_sk)
             where plan_sk in (SELECT plan_sk FROM work.stg_rpp_plan_scope_update);
      quit;

       proc sql;
          update di_dm2.calendar C
             set SCOPE_SK = (SELECT ec.SCOPE_SK
                               FROM work.stg_calendar_scope_update ec
                              WHERE C.cal_sk = ec.cal_sk)
           where cal_sk in (SELECT cal_sk FROM work.stg_calendar_scope_update);
      quit;

   %end;
   %else %do;

      %di_dm_trans_update(
         upload_lib=work,
         upload_table=stg_rpp_plan_scope_update,
         update_table=rpp_plan,
         sql= %str(update di_trans.rpp_plan p
               set SCOPE_SK = (SELECT ec.SCOPE_SK FROM work.stg_rpp_plan_scope_update ec
                                WHERE p.plan_sk = ec.plan_sk),
               OBJECTIVE_SK = (SELECT ec.SCOPE_SK FROM work.stg_rpp_plan_scope_update ec
                                WHERE p.plan_sk = ec.plan_sk)
               where plan_sk in (SELECT plan_sk FROM work.stg_rpp_plan_scope_update))
           );

      %di_dm_trans_update(
         upload_lib=work,
         upload_table=stg_calendar_scope_update,
         update_table=calendar,
         sql= %str(update di_trans.calendar C
            set SCOPE_SK = (SELECT ec.SCOPE_SK FROM work.stg_calendar_scope_update ec
                             WHERE C.cal_sk = ec.cal_sk)
          where cal_sk in (SELECT cal_sk FROM work.stg_calendar_scope_update))
         );

   %end;


%mend update_plan_and_cal_scope;

%update_plan_and_cal_scope;

/**  Step end Table Loader **/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            UW_Rpp_Notification                     A5W0V4GZ.BH0007P5 *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    RPP_PLAN - DI_DM2.RPP_PLAN              A5W0V4GZ.BB0003JT *
 * Target Table:    RPP_NOTIFICATION -                      A5W0V4GZ.BB0003JR *
 *                   DI_DM2.RPP_NOTIFICATION                                  *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%let etls_table = %nrquote(RPP_NOTIFICATION);
%let etls_lib   = %nrquote(DI_DM2);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;

%etls_recordCheck(source_table = DI_DM2.RPP_NOTIFICATION,
                  _record_count_var = etls_recordsBefore);

/*============================================================================*
 * Step:            Rpp Notification for Rpp_plan scope change                *
 *============================================================================*/

data work.update_rec_plan(rename=(plan_sk=object_sk ));
   attrib attr_1 length = $100;
   set work.stg_rpp_plan_scope_update;
   attr_1 = object_nm;
   updated_dttm=datetime();
   format updated_dttm datetime20.;
   object_cat_type=10;
   message_sk=15;
   drop object_nm;
run;

%di_dm_trans_append(di_trans=DI_DM2,
                    trans_table=RPP_NOTIFICATION,
                    append_table=update_rec_plan,
                    bulkload=0, fk_flag=0,
                    upload_flag=0);


/*============================================================================*
 * Step:            Rpp Notification for Calendars scope change               *
 *============================================================================*/

data update_rec_calendar(rename=(cal_sk=object_sk cal_type=object_cat_type));
   attrib attr_1 length = $100;
   set stg_calendar_scope_update;
   attr_1 = cal_nm;
   drop cal_nm;
   updated_dttm=datetime();
   format updated_dttm datetime9.;
   if cal_type=1 then message_sk=7;
   else if cal_type=2 then message_sk=8;
   else if cal_type=3 then message_sk=9;
   else if cal_type=4 then message_sk=10;
run;

%di_dm_trans_append(di_trans=DI_DM2,
                    trans_table=RPP_NOTIFICATION,
                    append_table=update_rec_calendar,
                    bulkload=0, fk_flag=0,
                    upload_flag=0);

%let etls_recordsAfter = 0;

%etls_recordCheck(source_table = DI_DM2.RPP_NOTIFICATION,
                  _record_count_var = etls_recordsAfter);


%etls_sendJobStatus(source_table = DIDM_STG.STG_SCOPE);



/*---- End of User Written Code  ----*/

/*---- Start of User Written Code  ----*/

/*============================================================================*
 * Step:            Table Loader                            A5RCIHUB.$0001031 *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    CALENDAR - DI_DM2.CALENDAR              A5RCIHUB.BR0007K0 *
 * Target Table:    RPP_OBJECT_ASSOC -                      A5RCIHUB.BR0007K7 *
 *                   DI_DM2.RPP_OBJECT_ASSOC                                  *
 *============================================================================*/

%let etls_recordsBefore = 0;

%let etls_table = %nrquote(RPP_OBJECT_ASSOC);
%let etls_lib   = %nrquote(DI_DM2);

%etls_recordCheck(source_table = DI_DM2.RPP_OBJECT_ASSOC,
                  _record_count_var = etls_recordsBefore);

 %di_dm_trans_delete(
         di_trans=DI_DM2,
         trans_table=RPP_OBJECT_ASSOC,
         delete_join_table=stg_calendar_scope_update,
         delete_join_cond=%str((a.FROM_OBJECT_SK=b.cal_SK and a.from_object_cat_type = b.cal_type)
                             OR (a.TO_OBJECT_SK=b.cal_SK and a.to_object_cat_type = b.cal_type))
        );

/* Get number of records in table  */
%let etls_recordsAfter = 0;
%etls_recordCheck(source_table = DI_DM2.RPP_OBJECT_ASSOC,
                  _record_count_var = etls_recordsAfter);

%etls_sendJobStatus(source_table = DIDM_STG.STG_SCOPE);

/*============================================================================*
 * Step:            Load Scope_detail with unique_scope prod-geo combinations *
 *============================================================================*/

%di_etl_keep_work_table(unique_scope_detail recent_scope_sk);

%let etls_recordsBefore = 0;

%let etls_table = %nrquote(SCOPE_DETAIL);
%let etls_lib   = %nrquote(DI_DM2);

%etls_recordCheck(source_table = DI_DM2.SCOPE_DETAIL,
                  _record_count_var = etls_recordsBefore);


data scope_detail_final;
   merge unique_scope_detail
         recent_scope_sk;
   by scope_nm;
   if not missing(scope_sk);
   keep scope_sk geo_hier_sk prod_hier_sk;
run;

%di_dm_trans_append(
   di_trans=di_dm2,
   trans_table=Scope_detail,
   append_table=scope_detail_final,
   bulkload=0,
   fk_flag=0,
   upload_flag=0
);

/* Get number of records in table  */
%let etls_recordsAfter = 0;
%etls_recordCheck(source_table = DI_DM2.SCOPE_DETAIL,
                  _record_count_var = etls_recordsAfter);

%etls_sendJobStatus(source_table = DIDM_STG.STG_SCOPE);

/* Refresh load the PROD_SCOPE_DETAIL and GEO_SCOPE_DETAIL tables */
%etls_recordCheck(source_table = DI_DM2.PROD_SCOPE_DETAIL, _record_count_var = etls_recordsBefore);

%di_dm_trans_delete(di_trans=di_trans,trans_table=PROD_SCOPE_DETAIL);

%di_dm_trans_exe(
   pass_through_sql=%str(insert into di_trans.PROD_SCOPE_DETAIL (scope_sk, prod_hier_sk)
      select distinct scope_sk, prod_hier_sk from di_trans.scope_detail)
);

%etls_recordCheck(source_table = DI_DM2.PROD_SCOPE_DETAIL, _record_count_var = etls_recordsAfter);

%let etls_table = %nrquote(PROD_SCOPE_DETAIL);
%let etls_lib   = %nrquote(DI_DM2);
%etls_sendJobStatus;

%etls_recordCheck(source_table = DI_DM2.GEO_SCOPE_DETAIL, _record_count_var = etls_recordsBefore);

%di_dm_trans_delete(di_trans=di_trans,trans_table=GEO_SCOPE_DETAIL);

%di_dm_trans_exe(
   pass_through_sql=%str(insert into di_trans.GEO_SCOPE_DETAIL (scope_sk, geo_hier_sk)
      select distinct scope_sk, geo_hier_sk from di_trans.scope_detail)
);

%etls_recordCheck(source_table = DI_DM2.GEO_SCOPE_DETAIL, _record_count_var = etls_recordsAfter);

%let etls_table = %nrquote(GEO_SCOPE_DETAIL);
%let etls_lib   = %nrquote(DI_DM2);
%etls_sendJobStatus;

/**  Step end Table Loader **/


/*---- End of User Written Code  ----*/

/*---- Start of Post-Process Code  ----*/

%macro etl_scope_delete_temp;
   %if "&etlp_delete_work_table" eq "Y" %then %do;
      proc datasets library = work kill nolist nowarn memtype=(data view);
      quit;
   %end;
%mend etl_scope_delete_temp;

%etl_scope_delete_temp;
/*---- End of Post-Process Code  ----*/

%di_etl_rcSet(error=&syserr,code=job_rc);
%di_etl_rcSet(error=&sqlrc,code=job_rc);;

%let etls_endTime = %sysfunc(datetime(),datetime.);

